

(*** THIS FILE IS GENERATED BY KRAKATOA - DO NOT EDIT ***)
(* Coq Model generated by Krakatoa. Do not edit *)

Add LoadPath "/software/lib/krakatoa".
Require Export preambule.
Require Export classes.
Require Export local_memory.
Require Export ZArith.
Require Export java_base.
Require Export Rbase.
Require Export Rfunctions.


Module KrakClasses.

(* Classes *)

Inductive classIdI : Set :=
| Object : classIdI
| Math : classIdI
| Integer : classIdI
| Lesson1 : classIdI
| String : classIdI
| System : classIdI
| Throwable : classIdI
| Exception : classIdI
| RuntimeException : classIdI
.
Definition classId := classIdI.

Definition ObjectClass := Object.

Definition eq_classId_dec : forall (i1 i2:classId), {i1=i2}+{~i1=i2}.
decide equality. Defined.

Definition super (i:classId) : (option classId) :=
  match i with
  | Object => None
  | Math => (Some Object)
  | Integer => (Some Object)
  | Lesson1 => (Some Object)
  | String => (Some Object)
  | System => (Some Object)
  | Throwable => (Some Object)
  | Exception => (Some Throwable)
  | RuntimeException => (Some Exception)
  end.

Lemma superObject : (super ObjectClass)=None.
auto. Save.

Lemma wf_Object : (Acc (fun i1 i2 => (def (super i2) i1)) Object).
constructor; simpl; intros.
case (undef_not_def (A:=classId) (x:=None)) with y; auto.
Defined.

Lemma wf_Math : (Acc (fun i1 i2 => (def (super i2) i1)) Math).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_Integer : (Acc (fun i1 i2 => (def (super i2) i1)) Integer).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_Lesson1 : (Acc (fun i1 i2 => (def (super i2) i1)) Lesson1).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_String : (Acc (fun i1 i2 => (def (super i2) i1)) String).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_System : (Acc (fun i1 i2 => (def (super i2) i1)) System).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_Throwable : (Acc (fun i1 i2 => (def (super i2) i1)) Throwable).
constructor; simpl; intros.
replace y with Object; auto.
apply wf_Object.
Defined.

Lemma wf_Exception : (Acc (fun i1 i2 => (def (super i2) i1)) Exception).
constructor; simpl; intros.
replace y with Throwable; auto.
apply wf_Throwable.
Defined.

Lemma wf_RuntimeException : (Acc (fun i1 i2 => (def (super i2) i1)) RuntimeException).
constructor; simpl; intros.
replace y with Exception; auto.
apply wf_Exception.
Defined.

Lemma super_wf : (well_founded (fun i1 i2 => (def (super i2) i1))).
red; intros.
case a.
apply wf_Object.
apply wf_Math.
apply wf_Integer.
apply wf_Lesson1.
apply wf_String.
apply wf_System.
apply wf_Throwable.
apply wf_Exception.
apply wf_RuntimeException.
Defined.

End KrakClasses.

Import KrakClasses.
Module KrakObj := (ObjectAdr KrakClasses).
Module KrakGen := KrakObj.CGen.


(* Require Export ZArith. *)
Require Export Why.
(* Add LoadPath "/software/lib/krakatoa". *)
(* Require Export replace. *)
(* Require Export Krak_model. *)
Export KrakClasses.
Export KrakGen.
Export KrakObj.
Export CGen.

(* Load local_model_imports. *)

Definition Exception_invariant := fun (this : value) => True.

Definition Integer_invariant := fun (this : value) => True.

Definition Lesson1_invariant := fun (this : value) => True.

Parameter Math_PI : R.

Axiom Math_PI_value : (Math_PI=(decimal_exp (IZR 314) (-2))).

Parameter Math_abs : R -> R.

Axiom Math_abs_axiom : forall (n:R),(let result := (Math_abs n) in True).

Parameter Math_abs_int : store -> Z -> Z.

Axiom Math_abs_int_axiom :
 forall (heap:store),
  forall (n:Z),(let result := (Math_abs_int heap n) in True).

Parameter Math_asin : R -> R.

Axiom Math_asin_axiom : forall (x:R),(let result := (Math_asin x) in True).

Parameter Math_atan2 : R -> R -> R.

Axiom Math_atan2_axiom :
 forall (x:R),forall (y:R),(let result := (Math_atan2 x y) in True).

Definition Math_invariant := fun (this : value) => True.

Parameter Math_max : R -> R -> R.

Axiom Math_max_axiom :
 forall (x:R),forall (y:R),(let result := (Math_max x y) in True).

Parameter Math_min : R -> R -> R.

Axiom Math_min_axiom :
 forall (x:R),forall (y:R),(let result := (Math_min x y) in True).

Parameter Math_sqrt : R -> R.

Axiom Math_sqrt_axiom : forall (x:R),(let result := (Math_sqrt x) in True).

Definition Object_equals := fun
 (heap : store)
 (this : value)
 (obj : value)
 => (this=obj).

Definition Object_invariant := fun (this : value) => True.

Definition RuntimeException_invariant := fun (this : value) => True.

Definition String_invariant := fun (this : value) => True.

Definition System_invariant := fun (this : value) => True.

Definition Throwable_invariant := fun (this : value) => True.

Hint Unfold Lesson1_invariant.
Hint Unfold Throwable_invariant.
Hint Unfold System_invariant.
Hint Unfold String_invariant.
Hint Unfold RuntimeException_invariant.
Hint Unfold Object_invariant.
Hint Unfold Math_invariant.
Hint Unfold Integer_invariant.
Hint Unfold Exception_invariant.



